﻿using System.Web.Http;
using AngularAspNetMvc.Models.Common;
using AngularAspNetMvc.Models.Core;
using AngularAspNetMvc.WebApi.Core;
using System.Collections.Generic;

namespace AngularAspNetMvc.WebApi.Common
{
    public class HomeController : RelayController
    {
        [HttpGet]
        public List<MenuItem> Menu()
        {
            return new List<MenuItem>
            {
                new MenuItem
                {
                    Path = "/home",
                    Controller = "homeController",
                    TemplateUrl = "home/home",
                    Title = "Home",
                    IsMenu = true
                },
                new MenuItem
                {
                    Path = "/contacttypes",
                    Controller = "app.contacts.contactsTypesController",
                    TemplateUrl = "contacttypes/index",
                    Title = "Contact Types",
                    IsMenu = true
                },
                new MenuItem
                {
                    Path = "/contacts",
                    Controller = "app.contacts.contactsController",
                    TemplateUrl = "contacts/index",
                    Title = "Contacts",
                    IsMenu = true
                },
                new MenuItem
                {
                    Path = "/contacttype/edit/:id",
                    Controller = "app.contacts.contactsTypesEditController",
                    TemplateUrl = "contacttypes/edit",
                    Title = "Contacts",
                    IsMenu = false
                }
            };
        }
    }
}
